/*****************************************************************************
*   $Id: vstring.h,v 1.1 1998/10/18 15:34:57 darren Exp $
*
*   Copyright (c) 1996-1998, Darren Hiebert
*
*   This source code is released for free distribution under the terms of the
*   GNU General Public License.
*
*   Provides the external interface for resizeable strings.
*****************************************************************************/
#ifndef _VSTRING_H
#define _VSTRING_H

#ifdef VSTRING_WRITE
# define CONST_VSTRING
#else
# define CONST_VSTRING const
#endif

/*============================================================================
=   Include files
============================================================================*/
#include "general.h"

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>	/* to define size_t */
#endif

/*============================================================================
=   Macros
============================================================================*/
#define vStringValue(vs)	((vs)->buffer)
#define vStringSize(vs)		((vs)->size)

/*============================================================================
=   Data declarations
============================================================================*/

typedef CONST_VSTRING struct _vString {
    size_t	length;		/* size of buffer used */
    size_t	size;		/* allocated size of buffer */
    char *	buffer;		/* location of buffer */
} vString;

/*============================================================================
=   Function prototypes
============================================================================*/
extern boolean vStringAutoResize __ARGS((vString *const string));
extern void vStringClear __ARGS((vString *const string));
extern vString *vStringNew __ARGS((void));
extern void vStringDelete __ARGS((vString *string));
extern void vStringPut __ARGS((vString *const string, const int c));
extern void vStringCat __ARGS((vString *const string, const char *const s));

#endif	/* _VSTRING_H */
